--SOC
sfxinfo[sfx_s1bd].caption = "Spikes!"
sfxinfo[sfx_s222].caption = "Shield spikes"
sfxinfo[sfx_s22b].caption = "Air jump"
sfxinfo[sfx_s255].caption = "Spike shield formed"
sfxinfo[sfx_cdfm14].caption = "All system are go!"
sfxinfo[sfx_cdfm35].caption = "Launch the spike ball!"
sfxinfo[sfx_cdfm41].caption = "Spike boost"
sfxinfo[sfx_kc5f].caption = "Jump"
sfxinfo[sfx_kc55].caption = "Back to normal"


--Just reset the whole damn thing
local function fuckGoBack(p)
	if p.valid
		if p.dango
			S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p, 0, 0, 500, 2*MUSICRATE)
		end
		p.ztimer = 0
		p.dango = false
		p.slimeGhost = nil
		p.spikeGhost = nil
		p.spikeBoost = 0
		p.restIdle = false
		p.yawnTime = 0
		p.yawnStretch = false
		p.yawnJiggle = false
		p.yawnUnstretch = false
		p.goodnight = false
		p.sleepyTime = 0
		p.tackleCharge = 0
		p.spikeBall = false
		p.bounce = false
		p.jompDistort = false
		p.suddenStop = false
		p.prevthokked = nil
		p.lstate = nil
		p.pmomz = 0
		p.pflags = $ & ~PF_STASIS & ~PF_SPINNING
		p.spinTackle = false
		p.jompTimer = 0
		if p.mo.valid
			if ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) )
				p.mo.state = S_PLAY_STND
			end
			p.mo.squish = false
			p.mo.afterSquish = false
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			p.mo.flags = $ & ~MF_NOGRAVITY
		end
	end
end

--Resetting the eyes by deleting them
local function uguuReset(mo)
	if mo.valid and mo.player.valid
		if mo.player.kawaiieyes 
			if mo.player.kawaiieyes.valid
				P_RemoveMobj(mo.player.kawaiieyes)
			end
			mo.player.kawaiieyes = nil
		end
	end
end

--Resetting a slime's shield state off a player
local function slimeShieldReset(p, damageOnReset)
	if p.followShield
		p.pflags = $ & ~PF_GODMODE
		if damageOnReset
			P_DamageMobj(p.mo)
		end
		if p.followShield and p.followShield.valid
			P_RemoveMobj(p.followShield)
		end
		if p.shieldSeeker and p.shieldSeeker.valid
			p.shieldSeeker.player.slimeShield = nil
			p.shieldSeeker = nil
		end
		p.mo.tracer = nil
		p.shieldChosen = nil
		p.followShield = nil
		p.homingSafety = 0
		p.becomeShield = nil
		p.mo.flags = $ & ~MF_NOGRAVITY & ~MF_NOCLIP
		uguuReset(p.mo)
		fuckGoBack(p)
		p.mo.z = $+FRACUNIT*P_MobjFlip(p.mo)
		P_InstaThrust(p.mo, InvAngle(p.mo.angle), 6*FRACUNIT)
		P_SetObjectMomZ(p.mo, 3*FRACUNIT)
		S_StartSoundAtVolume(p.mo, sfx_kc55, 150)
	end
end

--Go! Go! Spike Ball!
local function doTackle(p)
	p.mo.spritexscale = FRACUNIT
	p.mo.spriteyscale = FRACUNIT
	p.spikeBall = true
	p.bounce = true
	p.mo.state = S_SBAL
	p.mo.z = $ + FRACUNIT*P_MobjFlip(p.mo)
	--underwater momentum dampening oh no!
	if p.mo.eflags & MFE_UNDERWATER
		p.mo.momx = 20*cos(p.mo.angle)
		p.mo.momy = 20*sin(p.mo.angle)
		P_SetObjectMomZ(p.mo, 5*FRACUNIT, false)
	else
		p.mo.momx = 40*cos(p.mo.angle)
		p.mo.momy = 40*sin(p.mo.angle)
		P_SetObjectMomZ(p.mo, 8*FRACUNIT, false)
	end
	if p.mo.standingslope and p.mo.standingslope.zangle
		P_Thrust(p.mo, p.mo.standingslope.zangle, 3*FRACUNIT)
	end
	p.pflags = $|PF_SPINNING
end

--Lazy death checker. Yes I know it's mispelled
--(do I need this to be a function?)
local function didHeDied(p)
	if not p
	or not p.valid
	or not p.mo
	or not p.mo.valid
	or (p.mo.state == S_PLAY_DEAD or p.mo.state == S_PLAY_DRWN)
		return true
	else
		return false
	end
end

--Wibbly wobbly idle jiggling
local function idleJiggle(mo, stage)
	local distortion = sin(2*FixedAngle(stage*FRACUNIT))/1000
	mo.spritexscale = $ + distortion
	mo.spriteyscale = $ - distortion
end

local function returningLockOn(player, target, state)
	if not (player.mo.valid) or not (player.mo.info == mobjinfo[MT_PLAYER]) then return nil end
	if not (target.valid) then return nil end
	if not (states[state]) then return nil end
	local lockOnMo = nil
	if player == displayplayer
		lockOnMo = P_SpawnMobj(target.x, target.y, target.z, MT_LOCKON)
		lockOnMo.target = target
		lockOnMo.flags2 = $|MF2_DONTDRAW
		P_SetMobjStateNF(lockOnMo, state)
	end
	return lockOnMo
end

local function makeSplats(mo, splatStartSpeed)
	if P_IsObjectOnGround(mo) and leveltime%2 and mo.player.speed > splatStartSpeed
		local destZ = 0
		if not (mo.floorrover) then destZ = -10*FRACUNIT end
		local splat = P_SpawnMobjFromMobj(mo, 0,0, destZ, MT_SLIMESPLAT)
		splat.flags2 = $|MF2_SPLAT
		splat.renderflags = $|RF_OBJECTSLOPESPLAT
		--splat.blendmode = AST_SUBTRACT
		splat.angle = mo.player.drawangle
		P_TeleportMove(splat, mo.x - cos(mo.player.drawangle)*25, mo.y - sin(mo.player.drawangle)*25, splat.z)
		if P_RandomFixed()%2
			P_TeleportMove(splat, splat.x + cos(splat.angle)*(P_RandomFixed()%15) , splat.y , splat.z)
		else
			P_TeleportMove(splat, splat.x - cos(splat.angle)*(P_RandomFixed()%15) , splat.y , splat.z)
		end
		splat.scale = FRACUNIT/((P_RandomFixed()%4)+2)
		splat.scalespeed = FRACUNIT/24
		splat.destscale = 1
		splat.color = mo.color
	end
end

--Even wobblier jiggling for walking and running. Gets stronger based on the MOM source provided
rawset(_G, "P_JogJiggle", function(mo, stage, momsource)
	local adjustedMom = (momsource/FRACUNIT)/2
	local distortion = sin( FixedAngle(stage*FRACUNIT)*adjustedMom )/3
	local destscaleX = FRACUNIT + distortion
	local destscaleY = FRACUNIT - distortion
	if not (mo.spritexscale == destscaleX) then mo.spritexscale = $ - (abs($) - destscaleX)/5 end
	if not (mo.spriteyscale == destscaleY) then mo.spriteyscale = $ - (abs($) - destscaleY)/5 end
end)

--Squishing the boi on landing
rawset(_G, "P_LandingSquish", function(mo)
	if mo.squish
		--maybe spawn some slime circles here from a high fall
		mo.spritexscale = $+(FRACUNIT/25)
		mo.spriteyscale = $-(FRACUNIT/25)
		if mo.spritexscale >= FRACUNIT+FRACUNIT/4
			mo.squish = false
			mo.afterSquish = true
		end
	end
	if(mo.afterSquish)
		mo.spritexscale = $ - (abs($)-FRACUNIT)/5
		mo.spriteyscale = $ - (abs($)-FRACUNIT)/5
		if mo.spritexscale > 95*FRACUNIT/100 and mo.spritexscale < 105*FRACUNIT/100
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
			mo.afterSquish = false
		end
	end
end)

--Regular clamp for limiting values
rawset(_G, "P_Clamp", function(val, minv, maxv)
	return min(max(val, minv), maxv)
end)

--Pre-jump preparations so we can reset everything relevant to a jump
--(does this need to be rawset...? oh well.)
rawset(_G, "P_WindupPrep", function(p)
	if p.valid and p.mo.valid and not (p.jompTimer)
		if p.kawaiieyes and p.kawaiieyes.valid
			p.kawaiieyes.spritexscale = FRACUNIT
			p.kawaiieyes.spriteyscale = FRACUNIT
			p.kawaiieyes.custz = 1
			p.kawaiieyes.jompTimer = 1
			p.kawaiieyes.blinkTimer = 0
			p.kawaiieyes.blink = false
			p.kawaiieyes.blonk = false
		end
		p.mo.squish = false
		p.mo.afterSquish = false
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
		p.jompTimer = 1
	end
end)

--Limiting our movement while in spike ball form
addHook("PreThinkFrame", function()
	for p in players.iterate
		if p.mo and p.mo.skin == "slime"
		
			if p.spikeBall
				p.cmd.forwardmove = P_Clamp(p.cmd.forwardmove, -25, 5)
				p.cmd.sidemove = P_Clamp(p.cmd.sidemove, -10, 10)
			elseif p.becomeShield
				p.cmd.forwardmove = P_Clamp(p.cmd.forwardmove, -1, 1)
				p.cmd.sidemove = P_Clamp(p.cmd.sidemove, -1, 1)
			end
			
			if p.goodnight and (p.cmd.forwardmove or p.cmd.sidemove or not P_IsObjectOnGround(p.mo))
				p.goodnight = false
				uguuReset(p.mo)
				fuckGoBack(p)
				p.mo.z = $+FRACUNIT*P_MobjFlip(p.mo)
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
				S_StartSoundAtVolume(p.mo, sfx_kc55, 150)
			end
			
		end
	end
end)

--Everything, really.
addHook("ThinkFrame", function()
	for p in players.iterate
		
		--Emergency reset for players being targetted by a slime's homing attack
		if p.shieldChosen and not p.SCTimer
			p.SCTimer = 1
		end
		if p.SCTimer and p.SCTimer < TICRATE*2
			p.SCTimer = $+1
			if p.SCTimer == TICRATE*2
				p.shieldChosen = false
				p.SCTimer = 0
			end
		end
		
		--Reseting invalid slime shields
		if p.slimeShield and not p.slimeShield.valid
			p.shieldChosen = false
			p.slimeShield = nil
		end
		
		--We changed characters during a distortion or general alteration. Reset everything.
		if p.mo and ( p.jompTimer or p.mo.squish or p.mo.afterSquish or p.kawaiieyes or p.goodnight ) and not (p.mo.skin == "slime")
			fuckGoBack(p)
			uguuReset(p.mo)
		end
		
		--And here we go
		if p.mo and p.mo.skin == "slime"
			
			--Making sure things we get at the end of a frame are initialized
			if not p.pmomx then p.pmomx = 1 end
			if not p.pmomy then p.pmomy = 1 end
			if not p.pmomz then p.pmomz = 1 end
			if not p.lstate then p.lstate = S_PLAY_STND end
			
			--lining ourselves up when being carried
			--		"can't you just add a new, proper hanging sprite instead?"
			--great idea! now shut up
			if ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) )
				if p.powers[pw_carry]
					p.jompDistort = false
					p.mo.spriteyoffset = 15*FRACUNIT
					p.mo.spritexscale = FRACUNIT
					p.mo.spriteyscale = FRACUNIT
					if p.kawaiieyes and p.kawaiieyes.valid
						p.kawaiieyes.spritexscale = FRACUNIT
						p.kawaiieyes.spriteyscale = FRACUNIT
					end
				else
					p.mo.spriteyoffset = 0
				end
			end
		
			--No drowning for us
			p.powers[pw_underwater] = 9001
			
			--keeping this on so we don't have to worry about shield abilities
			p.pflags = $|PF_THOKKED
			
			--Idle jiggling, sort of like a breathing movement (even though slimes probably don't breathe)
			if (p.panim == PA_IDLE or p.panim == PA_EDGE) and not p.commenceTheJigglin and not p.jompTimer and not p.goodnight and ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) )
				if not (p.jiggleStart)
					p.jiggleStart = 1
				end
				idleJiggle(p.mo, p.jiggleStart)
				p.jiggleStart = $ + 1
			elseif not (p.commenceTheJigglin)
				p.jiggleStart = 0
			end
			
			--Getting tired...
			if (p.panim == PA_IDLE or p.panim == PA_EDGE) and ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) ) and not p.goodnight
				local timeForSleep = 18
				if not p.sleepyTime then p.sleepyTime = 1 end
				if p.sleepyTime < TICRATE*timeForSleep
					p.sleepyTime = $+1
					if p.sleepyTime >= TICRATE*timeForSleep
						p.goodnight = true
					end
				end
			elseif not (p.panim == PA_IDLE) or not (p.panim == PA_EDGE)
				p.sleepyTime = 0
			end
			
			--Sleep tight
			if p.goodnight then
				if p.kawaiieyes and p.kawaiieyes.valid and not p.kawaiieyes.goodnight
					p.kawaiieyes.blink = false
					p.kawaiieyes.blonk = false
					p.kawaiieyes.custz = 1
					p.kawaiieyes.spritexscale = FRACUNIT
					p.kawaiieyes.spriteyscale = FRACUNIT
					p.kawaiieyes.goodnight = true
					p.kawaiieyes.yawnStart = true
				end
				--Our eyes are doing their thing, so let's start stretching as we yawn.
				--Divided in 3 phases: raising, slight jiggling and going back to normal
				if p.yawnStretch or p.yawnJiggle or p.yawnUnstretch or p.restIdle
					if p.yawnStretch
						p.mo.spriteyscale = $ + FRACUNIT/175
						p.mo.spritexscale = $ - FRACUNIT/175
						if p.mo.spriteyscale >= FRACUNIT + FRACUNIT/10
							p.yawnStretch = false
							p.yawnJiggle = true
						end
					end
					if p.yawnJiggle
						if not p.yawnTime then p.yawnTime = 1 end
						if leveltime%6 > 2
							p.mo.spriteyscale = $ + FRACUNIT/100
							p.mo.spritexscale = $ - FRACUNIT/100
						else
							p.mo.spriteyscale = $ - FRACUNIT/100
							p.mo.spritexscale = $ + FRACUNIT/100
						end
						p.yawnTime = $ + 1
						if p.yawnTime >= 72
							p.yawnTime = 0
							p.yawnJiggle = false
							p.yawnUnstretch = true
						end
					end
					if p.yawnUnstretch
						p.mo.spriteyscale = $ - FRACUNIT/175
						p.mo.spritexscale = $ + FRACUNIT/175
						if p.mo.spriteyscale <= FRACUNIT - FRACUNIT/5
							p.yawnUnstretch = false
							p.restIdle = true
						end
					end
					if p.restIdle
					
						--timer for spawning Z bubbles
						if not p.ztimer then p.ztimer = 1 end
						if not (p.ztimer%P_RandomRange(65, 85)) or p.ztimer == 86
							local zbubble = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-10,10)*FRACUNIT, P_RandomRange(-10,10)*FRACUNIT ,p.mo.height - p.mo.height/5, MT_SLEEPZ)
							zbubble.xdir = P_RandomRange(-5,5)*FRACUNIT/36
							zbubble.ydir = P_RandomRange(-5,5)*FRACUNIT/36
							zbubble.tracer = p.mo
							zbubble.scale = 1
							zbubble.scalespeed = FRACUNIT/60
							zbubble.destscale = FRACUNIT/3
							p.ztimer = 1
						end
						p.ztimer = $+1
						
						if p.mo.spriteyscale < FRACUNIT - FRACUNIT/6
							p.mo.spriteyscale = $ + FRACUNIT/225
							p.mo.spritexscale = $ - FRACUNIT/225
						else
							if not p.jiggleStart then p.jiggleStart = 1 end
							idleJiggle(p.mo, p.jiggleStart)
							p.jiggleStart = $+1
						end
						
						--Dango, Dango, Dango. Dango, Dango Daikazoku
						local slimeFriendsForSong = 2
						local sleepingNearby = 0
						
						for sleepyBois in players.iterate
							if sleepyBois.mo and sleepyBois.mo.valid
								if sleepyBois.restIdle 
								and R_PointToDist2(p.mo.x, p.mo.y, sleepyBois.mo.x, sleepyBois.mo.y) < 150*FRACUNIT
								and not (sleepyBois == p) 
									sleepingNearby = $+1 
								end
							end
						end
						if sleepingNearby >= slimeFriendsForSong and not p.dango
							p.dango = true
							S_ChangeMusic("DANGO", true, p, 0, 0, 4*MUSICRATE, 4*MUSICRATE)
						elseif sleepingNearby < slimeFriendsForSong and p.dango
							p.dango = false
							S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p, 0, 0, 500, 2*MUSICRATE)
						end
						
					end
				end
			end
			
			--The jogging jiggle!
			if p.panim == PA_WALK or p.panim == PA_RUN
			and ( not (p.jompTimer) and not (p.mo.squish) and not (p.mo.afterSquish) and not (p.becomeShield) )
				if not (p.commenceTheJigglin)
					if not (p.mo.spritexscale == FRACUNIT)
						p.mo.spritexscale = $ - (abs($)-FRACUNIT)/8
						if p.mo.spritexscale > 95*FRACUNIT/100 and p.mo.spritexscale < 105*FRACUNIT/100 then p.mo.spritexscale = FRACUNIT end
					end
					if not (p.mo.spriteyscale == FRACUNIT)
						p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/8
						if p.mo.spriteyscale > 95*FRACUNIT/100 and p.mo.spriteyscale < 105*FRACUNIT/100 then p.mo.spriteyscale = FRACUNIT end
					end
					if p.mo.spritexscale == FRACUNIT and p.mo.spriteyscale == FRACUNIT then p.commenceTheJigglin = true end
				else
					if not (p.jiggleStart)
						p.jiggleStart = 1
					end
					p.jiggleStart = $ + 1
					if p.kawaiieyes and p.kawaiieyes.valid
						P_JogJiggle(p.kawaiieyes, p.jiggleStart, p.speed)
					end
					P_JogJiggle(p.mo, p.jiggleStart, p.speed)
					makeSplats(p.mo, 10*FRACUNIT)
				end
			else
				if p.commenceTheJigglin
					p.jiggleStart = 0
					p.mo.spritexscale = $ - (abs($)-FRACUNIT)/8
					p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/8
					if p.mo.spritexscale > 95*FRACUNIT/100 and p.mo.spritexscale < 105*FRACUNIT/100
						p.mo.spritexscale = FRACUNIT
						p.mo.spriteyscale = FRACUNIT
						p.commenceTheJigglin = false
					end
				end
			end
			
			--Looking for players holding down TOSSFLAG so we can target them and become their shields with a glomp
			--Uncomment the IF below if things gets slow iterating through every player every frame looking for valid shield targets
			if not (p.powers[pw_carry])
				local found = false
				for otherp in players.iterate
					--first check: making sure the target players aren't dying, and that "they: aren't ourselves
					if not (otherp == p)
					and not (didHeDied(otherp))
						--second check: player distance and angle validity
						local angleDiff = AngleFixed(p.mo.angle - R_PointToAngle2(p.mo.x, p.mo.y, otherp.mo.x, otherp.mo.y))/FRACUNIT
						if R_PointToDist2(p.mo.x, p.mo.y, otherp.mo.x, otherp.mo.y) <= RING_DIST
						and otherp.mo.z <= p.mo.z + 24*FRACUNIT
						and (angleDiff <= 45 or angleDiff >= 315)
							--third check: custom flags that invalidate a player from being shieldable
							if otherp.cmd.buttons & BT_TOSSFLAG
							and not otherp.slimeShield
							and not otherp.shieldSeeker
							and not otherp.becomeShield
							and not otherp.shieldChosen
							and not (p.powers[pw_shield])
							and not p.shieldSeeker
							and not p.becomeShield
							and not p.slimeShield
								if not p.mo.tracer or R_PointToDist2(p.mo.x, p.mo.y, otherp.mo.x, otherp.mo.y) <= R_PointToDist2(p.mo.x, p.mo.y, p.mo.tracer.x, p.mo.tracer.y)
									found = true
									local lock = returningLockOn(p, otherp.mo, S_SICO)
									if lock and lock.valid --99% sure I don't need valid here, but I'm too afraid of lua errors to let it slide
										lock.color = p.mo.color
									end
									p.mo.tracer = otherp.mo
								end
							end
						end
					end
				end
				if not found then p.mo.tracer = nil end
			end
			
			--Making our spiky ball bounce on stuff and break floors
			if p.lstate == S_SBAL and P_IsObjectOnGround(p.mo)
				--We'll enter the first condition on a successfull spike boost OR if we have one bounce left
				if p.bounce or (p.spikeBoost and p.spikeBoost > 10) then
					p.mo.state = S_SBAL
					p.mo.z = $ + FRACUNIT*P_MobjFlip(p.mo)
					--if we spike boosted...
					if p.spikeBoost and p.spikeBoost > 10
						p.mo.spritexscale = FRACUNIT
						p.mo.spriteyscale = FRACUNIT
						p.spikeBoost = 0
						if p.mo.eflags & MFE_UNDERWATER
							P_SetObjectMomZ(p.mo, P_Clamp(abs(p.pmomz) + FRACUNIT, 0, FRACUNIT*14), true)
						else
							P_SetObjectMomZ(p.mo, P_Clamp(abs(p.pmomz) + FRACUNIT*4, 0, FRACUNIT*14), true)
						end
						--and held forward...
						if p.cmd.forwardmove > 0
							p.pmomx = ((2*FRACUNIT + p.speed + p.speed/5)/FRACUNIT) * cos(p.mo.angle)
							p.pmomy = ((2*FRACUNIT + p.speed + p.speed/5)/FRACUNIT) * sin(p.mo.angle)
						else
							p.pmomx = $ + ($/5)
							p.pmomy = $ + ($/5)
						end
						S_StartSound(p.mo, sfx_cdfm40)
						p.bounce = true
					--...otherwise just send the player somewhere with reduced speed
					else
						if p.mo.eflags & MFE_UNDERWATER
							P_SetObjectMomZ(p.mo, P_Clamp(abs(p.pmomz) - FRACUNIT*2, 0, FRACUNIT*12), false)
						else
							P_SetObjectMomZ(p.mo, P_Clamp(abs(p.pmomz) + FRACUNIT*2, 0, FRACUNIT*12), false)
						end
						p.bounce = false
					end
					--slopes will boost us upwards
					if p.mo.standingslope and p.mo.standingslope.zangle
						P_Thrust(p.mo, p.mo.standingslope.zangle, 4*FRACUNIT)
					end
					p.pflags = $|PF_SPINNING
					S_StartSound(p.mo, sfx_pstop)
				--if we didn't spike boost and didn't have any bounces left, go back to normal
				else
					p.mo.z = $ + FRACUNIT*P_MobjFlip(p.mo)
					P_SetObjectMomZ(p.mo, abs(p.pmomz)/3, false)
					S_StartSoundAtVolume(p.mo, sfx_kc55, 150)
				end
				for rover in p.mo.subsector.sector.ffloors()
					--Sanity check for bustable FOFs
					if not (rover.flags & FF_EXISTS) or not (rover.flags & FF_BUSTUP) then continue end
					if p.mo.z >= rover.topheight + p.mo.height 
					or p.mo.z + p.mo.momz + p.mo.height < rover.bottomheight
						continue
					end
					EV_CrumbleChain(sector, rover)
				end
				p.mo.momx = p.pmomx
				p.mo.momy = p.pmomy
				--spawn either some dust or bubbles
				local whatToSpawn = nil
				if p.mo.eflags & MFE_UNDERWATER then whatToSpawn = MT_MEDIUMBUBBLE else whatToSpawn = MT_SPINDUST end
				local angles = 8
				local angle = 0
				for i = 0, angles - 1 do
					angle = FixedAngle(360*FRACUNIT/angles)*i
					local dust = P_SpawnMobjFromMobj(p.mo, 10*cos(angle), 10*sin(angle), 0, whatToSpawn)
					dust.momx = 8 * cos(angle)
					dust.momy = 8 * sin(angle)
				end
			end
			
			--Contingency stuff so our spike ball doesn't act weird
			if not (p.mo.state == S_SBAL) and p.spikeBall
				p.spikeBall = false
				p.bounce = false
				p.pflags = $ & ~PF_SPINNING
				p.mo.state = S_PLAY_SPRING
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
			end
			
			--More spike ball reset stuff and spike visuals
			if p.spikeBall
				if not (leveltime%2)
					local spook = P_SpawnGhostMobj(p.mo)
					spook.scalespeed = FRACUNIT/6
					spook.destscale = 0
				end
				if p.spikeBoost
					if p.spikeBoost > 16
						p.mo.spritexscale = $ + FRACUNIT/8
						p.mo.spriteyscale = $ + FRACUNIT/8
					elseif p.spikeBoost > 12
						p.mo.spritexscale = $ - FRACUNIT/8
						p.mo.spriteyscale = $ - FRACUNIT/8
					end
					if p.spikeBoost > 0 then p.spikeBoost = $ - 1 end
				end
			end
			
			--Almost the exact same as above, but for the shield boost pulse
			if p.becomeShield and p.shieldBoost
				if p.followShield and p.followShield.valid
					if p.shieldBoost > 16
						p.followShield.spritexscale = $ + FRACUNIT/18
						p.followShield.spriteyscale = $ + FRACUNIT/18
						p.followShield.spriteyoffset = $ - FRACUNIT
					elseif p.shieldBoost > 12
						p.followShield.spritexscale = $ - FRACUNIT/18
						p.followShield.spriteyscale = $ - FRACUNIT/18
						p.followShield.spriteyoffset = $ + FRACUNIT
					end
					if p.shieldBoost > 0 then p.shieldBoost = $ - 1 end
				end
			end
			
			--Left this in for funsies.
			--When the mod first started as a shitpost character, you could only move by jumping.
			--I got some pretty strong responses out of this so I opted to remove it, and that was for the best.
			
			/*
			if P_IsObjectOnGround(p.mo)
				p.pflags = $ | PF_STASIS
			else
				p.pflags = $ & ~PF_STASIS
			end
			*/
			
			--We slidin'
			p.mo.friction = 30*FRACUNIT/32
			
			--Resetting things out of springs
			if p.mo.eflags & MFE_SPRUNG
				fuckGoBack(p)
			end
			
			--If we're in the air then get some distortions going!
			if not (P_IsObjectOnGround(p.mo)) 
			and not (didHeDied(p)) and not p.spikeBall
			and not p.becomeShield and not p.powers[pw_carry]
				p.jompDistort = true
			end
			
			--Squishing ourselves a little bit to prepare for either a jump or a tackle
			if(p.jompTimer and p.jompTimer < 10)
				p.jompTimer = $+1
				p.mo.spritexscale = $+(FRACUNIT/25)
				p.mo.spriteyscale = $-(FRACUNIT/25)
				if(p.jompTimer == 10)
					p.jompTimer = 0
					if not P_IsObjectOnGround(p.mo)
						S_StartSound(p.mo, sfx_s22b)
						P_SpawnMobjFromMobj(p.mo, 0,0,0, MT_SLIMECIRC)
					end
					if p.spinTackle
						p.spinTackle = false
						doTackle(p)
						p.jompDistort = false
						S_StartSoundAtVolume(p.mo, sfx_cdfm14, 200)
						S_StartSoundAtVolume(p.mo, sfx_cdfm35, 125)
					else
						P_DoJump(p)
					end
				end
			end
			
			--Dynamic momz distortions in the air
			--Takes your momentum in consideration, as well as your distance from the ground
			if p.jompDistort and ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) )

				local distortScale = 25
				local fracsForDistortion = 25*FRACUNIT
				local floorDist = abs(p.mo.floorz - p.mo.z)
				local fracBullshit = P_Clamp(floorDist, 0, fracsForDistortion)/(fracsForDistortion/FRACUNIT)
				
				--I know the PF_JUMPSTARTED flag exists but this seems a bit better for the distortions I'm going for
				if abs(p.mo.momz - p.pmomz) >= 2*FRACUNIT and not (P_IsObjectOnGround(p.mo))
					p.suddenStop = true
				end
				
				if not p.suddenStop
					if abs(p.mo.momz)/FRACUNIT >= 1
						p.mo.spritexscale = FRACUNIT - P_Clamp(( FixedMul((abs(p.mo.momz)/distortScale), fracBullshit) ), 0, FRACUNIT/3)
						p.mo.spriteyscale = FRACUNIT + P_Clamp(( FixedMul((abs(p.mo.momz)/distortScale), fracBullshit) ), 0, 3*FRACUNIT/4)
					end
				else
					p.mo.spritexscale = $ - (abs($)-FRACUNIT)/8
					p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/8
					if p.mo.spritexscale > 95*FRACUNIT/100 and p.mo.spritexscale < 105*FRACUNIT/100
						p.mo.spritexscale = FRACUNIT
						p.mo.spriteyscale = FRACUNIT
						p.suddenStop = false
					end
				end
			end
			
			--We landed! Time to squish a bit
			if p.jompDistort and P_IsObjectOnGround(p.mo) and abs(p.pmomz) > FRACUNIT
				--if p.pmomz > 40*FRACUNIT
					--add some impact effects here like driplets flying off the slime
				--end
				S_StartSound(p.mo, sfx_wdrip8)
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				p.jompDistort = false
				p.mo.squish = true
			end
			
			--We got the squish command above, so let's run it
			if(p.mo.squish or p.mo.afterSquish)
				P_LandingSquish(p.mo)
				makeSplats(p.mo, 10*FRACUNIT)
			end
			
			--spike ball pulse image
			if p.spikeGhost
				if p.spikeGhost.valid
					P_TeleportMove(p.spikeGhost, p.mo.x, p.mo.y, p.mo.z - FRACUNIT*6*P_MobjFlip(p.mo))
				else
					p.spikeGhost = nil
				end
			end
			
			--regular slime pulse image
			if p.slimeGhost
				if p.slimeGhost.valid
					P_TeleportMove(p.slimeGhost, p.mo.x, p.mo.y, p.mo.z - FRACUNIT*6*P_MobjFlip(p.mo))
				else
					p.slimeGhost = nil
				end
			end
			
			--YOUR SHIELD IS THE SHIELD THAT WILL GUARD THE HEAVENS!
			--Checking for invalid shields
			if p.shieldSeeker and not p.shieldSeeker.valid and not p.becomeShield
				p.shieldSeeker = nil
				p.pflags = $ & ~PF_GODMODE
				p.mo.flags = $ & ~MF_NOGRAVITY & ~MF_NOCLIP
			end
			
			--Seeking out a valid player without a shield of their own
			--Repeating the conditions from the third step of player finding
			if p.shieldSeeker and p.shieldSeeker.valid and not p.becomeShield
			and p.shieldSeeker.player.cmd.buttons & BT_TOSSFLAG
			and not p.shieldSeeker.player.slimeShield and not (p.powers[pw_shield])
			and not p.shieldSeeker.player.shieldSeeker and not p.slimeShield
			and not p.shieldSeeker.player.becomeShield
				if not p.homingSafety then p.homingSafety = 1 end
				p.homingSafety = $ + 1
				p.pflags = $|PF_GODMODE
				p.shieldSeeker.flags2 = $|MF2_INVERTAIMABLE
				P_HomingAttack(p.mo, p.shieldSeeker)
				if R_PointToDist2(p.mo.x, p.mo.y, p.shieldSeeker.x, p.shieldSeeker.y) < 20*FRACUNIT
					if not p.shieldSeeker.player.powers[pw_shield]
						p.shieldSeeker.flags2 = $ & ~MF2_INVERTAIMABLE
						p.becomeShield = true
						p.mo.tracer = nil
						p.homingSafety = 0
						p.shieldSeeker.player.shieldChosen = false
					else
						p.homingSafety = 3*TICRATE
						P_InstaThrust(p.mo, InvAngle(p.mo.angle), 6*FRACUNIT)
						S_StartSoundAtVolume(p.mo, sfx_kc52, 180)
					end
				end
				if p.homingSafety > 2*TICRATE
					p.shieldSeeker.player.shieldChosen = false
					p.becomeShield = false
					p.shieldSeeker = nil
					p.homingSafety = 0
					p.pflags = $ & ~PF_GODMODE
				end
			else
				--very lazy code reuse.
				if p.homingSafety
					p.shieldSeeker.player.shieldChosen = false
					p.becomeShield = false
					p.shieldSeeker = nil
					p.homingSafety = 0
					p.pflags = $ & ~PF_GODMODE
				end
			end
			
			--You am become shield, protector or worlds
			if p.becomeShield
				if not p.followShield
					if p.kawaiieyes and p.kawaiieyes.valid
						p.kawaiieyes.spritexscale = FRACUNIT
						p.kawaiieyes.spriteyscale = FRACUNIT
						p.kawaiieyes.custz = 1
						p.kawaiieyes.jompTimer = 1
						p.kawaiieyes.blinkTimer = 0
						p.kawaiieyes.blink = false
						p.kawaiieyes.blonk = false
					end
					uguuReset(p.mo)
					p.mo.squish = false
					p.mo.afterSquish = false
					p.mo.spritexscale = FRACUNIT
					p.mo.spriteyscale = FRACUNIT
					S_StartSound(p.mo, sfx_s255)
					p.followShield = P_SpawnMobjFromMobj(p.mo, p.mo.x, p.mo.y, p.mo.z, MT_SPIKESHIELD)
					p.followShield.scale = FRACUNIT/2
					p.followShield.tracer = p.mo
					p.shieldSeeker.player.slimeShield = p.mo
				else
					if p.followShield and p.followShield.valid and p.shieldSeeker and p.shieldSeeker.valid
						P_TeleportMove(p.followShield, p.shieldSeeker.x, p.shieldSeeker.y, p.shieldSeeker.z)
						p.followShield.color = p.mo.color
						p.followShield.destscale = p.shieldSeeker.player.shieldscale
					end
				end
				if p.shieldSeeker and p.shieldSeeker.valid
					p.powers[pw_carry] = 0
					p.mo.flags = $|MF_NOGRAVITY|MF_NOCLIP
					p.mo.state = S_INVISIBLE
					P_TeleportMove(p.mo, p.shieldSeeker.x, p.shieldSeeker.y, p.shieldSeeker.z + (p.shieldSeeker.height*3)/4)
					if p.shieldSeeker.player.powers[pw_shield]
						slimeShieldReset(p, false)
					end
				else
					slimeShieldReset(p, false)
				end
			end
			
			--Making sure the shield is reset if something iffy happens
			if (p.followShield and not (p.followShield.valid)) 
			or (p.shieldSeeker and not (p.shieldSeeker.valid))
			or (p.becomeShield and p.powers[pw_shield])
				slimeShieldReset(p, false)
			end
			
			--Stuff to be used next frame using the current frame's values
			p.pmomx = p.mo.momx
			p.pmomy = p.mo.momy
			p.pmomz = p.mo.momz
			p.lstate = p.mo.state
			
			--A fresh pair of eyes
			if p.valid and p.mo.valid and not p.kawaiieyes and not (didHeDied(p)) and ( not (maptol & TOL_NIGHTS) or (maptol & TOL_NIGHTS and not (p.nightstime)) )
				p.kawaiieyes = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SLIMEEYES)
				p.kawaiieyes.angle = p.drawangle
				p.kawaiieyes.tracer = p.mo
			end
			if p.kawaiieyes and p.kawaiieyes.valid and not p.kawaiieyes.tracer
				p.kawaiieyes.tracer = p.mo
				p.kawaiieyes.angle = p.drawangle
			end
			
			--eh.
			if not (p.cmd.buttons & BT_SPIN) then
				p.spintapreadySLIME = true
				p.spintappingSLIME = false
			elseif p.spintapreadySLIME then
				p.spintappingSLIME = true
				p.spintapreadySLIME = false
			else
				p.spintappingSLIME = false
			end
			--eeeeh.
			if not (p.cmd.buttons & BT_JUMP) then
				p.jumptapreadySLIME = true
				p.jumptappingSLIME = false
			elseif p.jumptapreadySLIME then
				p.jumptappingSLIME = true
				p.jumptapreadySLIME = false
			else
				p.jumptappingSLIME = false
			end
			
			--nights stuff
			if (maptol & TOL_NIGHTS) and p.nightstime
				if p.cmd.buttons & BT_JUMP
					p.mo.spritexscale = FRACUNIT + sin(FixedAngle(leveltime*FRACUNIT)*15)/6
					p.mo.spriteyscale = FRACUNIT - sin(FixedAngle(leveltime*FRACUNIT)*15)/6
				else
					p.mo.spritexscale = $ - (abs($)-FRACUNIT)/5
					p.mo.spriteyscale = $ - (abs($)-FRACUNIT)/5
				end
				if P_IsObjectOnGround(p.mo) or p.mo.state == S_PLAY_NIGHTS_ATTACK
					p.mo.sprite = SPR_SBAL
				end
			end
			
		end
	end
end)

--PostThink for transparency stuff, placing our eyes manually and resetting our spike ball after a bounce
addHook("PostThinkFrame", function()
	for p in players.iterate
		if p.valid and p.mo and p.mo.valid and p.mo.skin == "slime"
			
			--transparency
			p.mo.frame = $ | TR_TRANS20
			
			--eye initialization stuff and manual vertical flipping
			if p.kawaiieyes and p.kawaiieyes.valid
				if not (p.kawaiieyes.custz) then p.kawaiieyes.custz = 1 end
				P_TeleportMove(p.kawaiieyes, p.mo.x + cos(p.drawangle), p.mo.y + sin(p.drawangle), p.mo.z + p.kawaiieyes.custz)
				if p.mo.eflags & MFE_VERTICALFLIP
					p.kawaiieyes.eflags = $|MFE_VERTICALFLIP
				else
					p.kawaiieyes.eflags = $ & ~MFE_VERTICALFLIP
				end
			end
			
			--resetting our ball state on bounces
			if p.bounce and not (p.mo.state == S_SBAL)
				p.mo.state = S_SBAL
				p.pflags = $|PF_SPINNING
			end
			
		end
	end
end)

--Overriding our regular jump key function so we can streeeetch before a jump
--Also used to wake the slime up and cancel the spike ball form
addHook("JumpSpecial", function(p)
	if not p.mo or not (p.mo.skin == "slime") then return end
		
		--regular jump for the CEZ mace swings
		if p.powers[pw_carry] & CR_MACESPIN or p.powers[pw_carry] & CR_ROPEHANG then return false end
		
		--jump and spin actions are disabled when starting a shield seeker
		if p.shieldSeeker and not p.becomeShield then return true end
		
		--Auto jump, because why not
		if P_IsObjectOnGround(p.mo) and not (p.jompTimer) and not (p.mo.state == S_SBAL) and not p.goodnight
			P_WindupPrep(p)
		end

		--Reverting from spike ball form
		if p.spikeBall and p.jumptappingSLIME
			p.spikeBall = false
			p.bounce = false
			p.spikeBoost = 0
			p.pflags = $ & ~PF_SPINNING
			p.mo.state = S_PLAY_SPRING
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			S_StartSoundAtVolume(p.mo, sfx_kc55, 150)
			p.slimeGhost = P_SpawnGhostMobj(p.mo)
			p.slimeGhost.destscale = 2*FRACUNIT
			return true
		end
		
		--Wakey wakey
		if p.goodnight then
			p.goodnight = false
			uguuReset(p.mo)
			fuckGoBack(p)
			p.mo.z = $+FRACUNIT*P_MobjFlip(p.mo)
			P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			S_StartSoundAtVolume(p.mo, sfx_kc55, 150)
			return true
		end
		
		--Going back from our shield form
		if p.becomeShield and p.jumptappingSLIME
			slimeShieldReset(p, false)
			return
		end
		
		--We picked a shield target! Fly towards them!
		if not P_IsObjectOnGround(p.mo) 
		and p.mo.tracer and p.mo.tracer.valid and p.mo.tracer.player
		and not (p.spikeBall) and p.jumptappingSLIME
			p.mo.tracer.player.shieldChosen = true
			p.shieldSeeker = p.mo.tracer
		end
		
		--do we NEED a jump ability...?
		--if not P_IsObjectOnGround(p.mo)
		--and not (p.spikeBall) and p.jumptappingSLIME
			--something
			--return
		--end

	return true
end)

--Spike baaaaall
addHook("SpinSpecial", function(p)
	
	--Same windup as the jump, but with a spike ball flag attached at the end
	if not p.mo or not (p.mo.skin == "slime") or p.goodnight then return end
	
	--Shield pulse for destroying enemies and monitors
	if p.becomeShield and p.spintappingSLIME 
	and p.followShield and p.followShield.valid
	and not p.shieldBoost
		p.shieldBoost = 20
		S_StartSound(p.mo, sfx_cdfm41)
		return true
	end
	
	if p.shieldSeeker then return true end
	
	--Spin tackle windup
	if P_IsObjectOnGround(p.mo) and not (p.spikeBall) and p.spintappingSLIME then
		p.spinTackle = true
		P_WindupPrep(p)
	end
	
	--Spike boost. you have a 10 frame window to hit it, and a 10 frame cooldown afterwards unless you hit the boost,
	--in which case the timer is set to 0. I imagine this could be fun with a TAS.
	if p.spikeBall and p.spintappingSLIME and not p.spikeBoost then
		p.spikeBoost = 20
		S_StartSound(p.mo, sfx_cdfm41)
		local spkb = P_SpawnMobjFromMobj(p.mo, 0,0,0, MT_SPIKEBOOST)
		spkb.tracer = p.mo
	end
	
	--Non-tackle version of becoming a spike ball used in the air
	if not (P_IsObjectOnGround(p.mo)) and not (p.spikeBall) and p.spintappingSLIME
	and (not (p.panim == PA_PAIN) and not (p.panim == PA_ETC))then
		p.jompDistort = false
		p.spikeBall = true
		p.bounce = true
		p.pflags = $|PF_SPINNING
		p.mo.state = S_SBAL
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
		S_StartSound(p.mo, sfx_s1bd)
		p.spikeGhost = P_SpawnGhostMobj(p.mo)
		p.spikeGhost.destscale = 2*FRACUNIT
	end
	
	return true
end)

--Spike ball SMASH spike!
addHook("MobjCollide", function(mo, spmo)
	if not (spmo.skin == "slime") or not (spmo.valid) or not (spmo.player) or not (spmo.player.valid) then return end
	if (spmo.z > mo.z + mo.height + FRACUNIT*10) or (mo.z > spmo.z + spmo.height) then return end
	if spmo.player.spikeBall
		S_StartSound(spmo, mo.info.deathsound)
		mo.health = 0
		P_KillMobj(mo, spmo, spmo)
		return false
	end
end, MT_SPIKE)

--SMASH WALL!!
addHook("MobjLineCollide", function(mo, line)
	if not mo or not mo.valid then return end
	if mo.skin == "slime" or mo.player.slimeShield
		if mo.player.spikeBall or mo.player.slimeShield
			for _, sec in ipairs({line.frontsector, line.backsector})
				for rover in sec.ffloors()
					if not (rover.flags & FF_EXISTS) or not (rover.flags & FF_BUSTUP) then continue end
					if mo.z >= rover.topheight + mo.height 
					or mo.z + mo.momz + mo.height < rover.bottomheight
						continue
					end
					EV_CrumbleChain(sector, rover)
				end
			end
		end
	end
end, MT_PLAYER)

--SMAAAAAAAASH!!
addHook("MobjCollide", function(mo, spmo)
	if not (spmo.skin == "slime") or not (spmo.valid) or not (spmo.player) or not (spmo.player.valid) then return end
	if (spmo.z > mo.z + mo.height + FRACUNIT*10) or (mo.z > spmo.z + spmo.height) then return end
	if spmo.player.spikeBall
		S_StartSound(spmo, mo.info.deathsound)
		mo.health = 0
		P_KillMobj(mo, spmo, spmo)
		return false
	end
end, MT_WALLSPIKE)

--We'll let spike shields bust monitors
addHook("MobjCollide", function(mo, pmo)
	if not (pmo) or not (pmo.valid) or not (pmo.player) then return end
	if (pmo.z > mo.z + mo.height + FRACUNIT*10) or (mo.z > pmo.z + pmo.height) then return end
	if mo and mo.valid and (mo.flags & MF_MONITOR)
	and pmo.player and pmo.player.slimeShield and pmo.player.slimeShield.valid and pmo.player.slimeShield.player 
	and pmo.player.slimeShield.player.shieldBoost and pmo.player.slimeShield.player.shieldBoost > 5
		P_KillMobj(mo, pmo.player.slimeShield, pmo.player.slimeShield)
		return false
	end
end)

--Ignoring bubbles. Breathing is for chumps
addHook("TouchSpecial", function(mo, pmo)
	if not (pmo.skin == "slime") or not (pmo.valid) or not (pmo.player) or not (pmo.player.valid) then return end
	return true
end, MT_EXTRALARGEBUBBLE)

--WHY IS THE STEAM FROM VENTS SO JANK?
addHook("MobjCollide", function(mo, pmo)
	if not (pmo.skin == "slime") 
	or not (mo) or not (mo.valid)
	or not (pmo.valid) or not (pmo.player) or not (pmo.player.valid) 
	or (pmo.z > mo.z + mo.height + FRACUNIT) or (mo.z > pmo.z + pmo.height) then return end
		fuckGoBack(pmo.player)
		pmo.player.jompDistort = true
end, MT_STEAM)

--Ignoring spike damage in our spike ball form and for slime shield users
--Also allowing the shield pulse to damage enemies
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not target.valid or not target.player or not target.player.valid then return end
	if target.skin == "slime" or target.player.slimeShield
		--for some reason spikes that raise from and sink into the ground seem to do a damage type different from DMG_SPIKE
		--so instead of just checking if we received spike damage we'll also specifically call the spike mobjs out on their bullshit
		if (damagetype == DMG_SPIKE 
		or (inflictor and inflictor.valid and (inflictor.type == MT_SPIKE or inflictor.type == MT_WALLSPIKE)) )
		and (target.player.spikeBall or target.player.slimeShield)
			return false
		end
		
		--Let's damage some enemies with our spike shield
		if inflictor and inflictor.valid and inflictor.flags & MF_ENEMY and inflictor.flags & MF_SPECIAL
		and target.player and target.player.slimeShield and target.player.slimeShield.valid
		and target.player.slimeShield.player.shieldBoost and target.player.slimeShield.player.shieldBoost > 5
			target.player.slimeShield.player.scoreadd = 0
			P_DamageMobj(inflictor, target.player.slimeShield, target.player.slimeShield)
			return false
		end
	end
end, MT_PLAYER)

--We bumped into something as a spike ball. Let's make some noise
addHook("MobjMoveBlocked", function(mo)
	if not (mo.skin == "slime") or not (mo.valid) or not (mo.player) or not (mo.player.valid) then return end
	if mo.player.spikeBall and mo.player.speed > 3*FRACUNIT
	
		--bounces are really iffy when grounded, so lift ourselves a bit beforehand
		if P_IsObjectOnGround(mo)
			mo.z = $+FRACUNIT*P_MobjFlip(mo)
		end
		P_BounceMove(mo)
		
		--sorta the same as a grounded spike boost, but for walls.
		if mo.player.spikeBoost and mo.player.spikeBoost > 10
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
			S_StartSound(mo, sfx_cdfm40)
			mo.player.bounce = true
			--we lose a LOT of speed on wall bounces, so let's really crank up that speed gain
			mo.momx = ($*2) + $/4
			mo.momy = ($*2) + $/4
			if mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(mo, FRACUNIT*4, true)
			else
				P_SetObjectMomZ(mo, FRACUNIT*8, true)
			end
			mo.player.spikeBoost = 0
		else
			mo.momx = $ + ($/2)
			mo.momy = $ + ($/2)
		end
		
		--Make some noise and create dust or bubbles on the walls or whatever stopped us
		S_StartSound(mo, sfx_pstop)
		for i = 1, 8 do --credits to Flame for helping with the vertical dust circles
			local zang = i*ANGLE_45
			local whatToSpawn = nil
			if mo.eflags & MFE_UNDERWATER then whatToSpawn = MT_MEDIUMBUBBLE else whatToSpawn = MT_SPINDUST end
			local dust = P_SpawnMobj(mo.x, mo.y, mo.z, whatToSpawn)
			dust.angle = InvAngle(mo.angle)
			dust.flags = $|MF_NOGRAVITY
			P_InstaThrust(dust, dust.angle+ANGLE_90, FixedMul(cos(zang), FRACUNIT*8))
			P_SetObjectMomZ(dust, FixedMul(sin(zang), FRACUNIT*2), false)
		end
	end
end, MT_PLAYER)

--Uh oh ya frigkin moron, you just got SLIMED! Spike ball your friends to totally SLIME them
addHook("MobjDamage", function(mo, inflictor, source, damage, damagetype)
	if not mo or not mo.valid then return end
	if inflictor and inflictor.valid and inflictor.player
	and inflictor.player.spikeBall
	and mo.health >= 2
		S_StartSound(mo, sfx_ghit)
		mo.colorized = true
		mo.color = inflictor.color
		mo.yaFrigkinMoron = TICRATE*4
	end
end)

--S L I M E D
addHook("MobjThinker", function(mo)
	if not mo or not mo.valid then return end
	if mo.yaFrigkinMoron and mo.yaFrigkinMoron > 1
		local wide = mo.radius/FRACUNIT
		local tall = mo.height/FRACUNIT
		mo.yaFrigkinMoron = $-1
		if not (leveltime%5)
			local droplet = P_SpawnMobjFromMobj(mo, P_RandomRange(-wide, wide)*FRACUNIT, P_RandomRange(-wide, wide)*FRACUNIT, P_RandomRange(-tall, tall)*FRACUNIT, MT_WATERDROP)
			droplet.colorized = true
			droplet.color = mo.color
		end
	elseif mo.yaFrigkinMoron == 1
		mo.yaFrigkinMoron = 0
		mo.colorized = false
		if mobjinfo[mo.type].color
			mo.color = mobjinfo[mo.type].color
		else
			mo.color = 0
		end
	end
end)

--And finally, ensuring everything gets reset when we spawn, are damaged, change maps, die or quit a netgame
addHook("PlayerSpawn", function(p)
	if p.mo and p.mo.valid and p.valid and p.mo.skin == "slime"
		slimeShieldReset(p, false)
		uguuReset(p.mo)
		fuckGoBack(p)
	end
end)
addHook("MapLoad", function(mapnum)
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.skin == "slime"
			slimeShieldReset(p, false)
			uguuReset(p.mo)
			fuckGoBack(p)
		end
	end
end)
addHook("MobjDeath", function(mo, inflictor, source, damagetype)
	if not mo or not mo.valid then return end
	if not mo.player or not mo.player.valid then return end
	if mo.skin == "slime"
		slimeShieldReset(mo.player, false)
		fuckGoBack(mo.player)
		uguuReset(mo)
		if mo.player.slimeShield and mo.player.slimeShield.valid
			mo.player.shieldChosen = false
			slimeShieldReset(mo.player.slimeShield.player, false)
			mo.player.slimeShield = nil
		end
	end
end, MT_PLAYER)
addHook("MobjDamage", function(mo, inflictor, source, damage, damagetype)
	if not mo or not mo.valid then return end
	if mo.skin == "slime" or mo.player.slimeShield
		if mo.player.slimeShield
			mo.player.powers[pw_shield] = SH_PITY
			if mo.player.slimeShield and mo.player.slimeShield.valid
				slimeShieldReset(mo.player.slimeShield.player, true)
				mo.player.slimeShield = nil
				mo.shieldChosen = false
			end
		end
		if mo.skin == "slime"
			uguuReset(mo)
			fuckGoBack(mo.player)
			return
		end
	end
end, MT_PLAYER)
addHook("PlayerQuit", function(p, reason)
	if p.valid and p.mo and p.mo.valid and p.mo.skin == "slime"
		slimeShieldReset(p, false)
		uguuReset(p.mo)
		fuckGoBack(p)
	end
end)

--
--                   OK0OkkkkkkOO0O
--               OxxxxxkkkOOOOOkkxxxxxk
--           Oxdxx0XWMMMMMMMMMMMMMMWX0kddx
--         OddkXWMMMMMMMMMMMMMMMMMMMMMMMNOdok
--       OodKWMMMMMMMMMMMMMMMMMMMMMMMMMMMMWKxok
--      oo0WMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMKdo0
--    OlxNMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMWOlk
--   OlOWMMMMMMMMMMMMMW KMMMMMMK NMMMMMMMMMMMMMM0lx
--  0lkWMMMMMMMMMMMMMM   WMMMMM   MMMMMMMMMMMMMMM0lk
-- NodNMMMMMMMMMMMMMMM   WMMMMM   MMMMMMMMMMMMMMMWxlK
-- OlOMMMMMMMMMMMMMMMM   WMMMMM   MMMMMMMMMMMMMMMMKlx
-- dlXMMMMMMMMMMMMMMMMW NMMMMMMN WMMMMMMMMMMMMMMMMWoo
-- ooNMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMWdl
-- xl0MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMXld
--  xlkNMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNOod
--   0xdxOXWMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMWX0xdd0
--      0xxxxxkOKXNWWMMMMMMMMMMMMMMWWNXK0kxxxxxO
--            xxxxxxxxxxxxxxxxxxxxxxxxxx    
-- 
